var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};

// src/label-parser.ts
import {
  arrowFunctionExpression as arrowFunctionExpression4,
  callExpression as callExpression5,
  identifier as identifier4,
  isAssignmentExpression,
  isBlockStatement,
  isExpressionStatement,
  isIdentifier as isIdentifier3,
  isSequenceExpression,
  isVariableDeclaration,
  variableDeclaration as variableDeclaration2,
  variableDeclarator as variableDeclarator2
} from "@babel/types";

// src/get-hook-identifier.ts
import { addNamed } from "@babel/helper-module-imports";
function getHookIdentifier(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = addNamed(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}

// src/memo-variable.ts
import {
  arrowFunctionExpression,
  identifier,
  objectExpression,
  objectProperty as objectProperty2,
  spreadElement,
  stringLiteral
} from "@babel/types";

// src/accessor-variable.ts
import {
  callExpression as callExpression2
} from "@babel/types";

// src/deref-memo-expression.ts
import {
  callExpression,
  isArrayPattern,
  isArrowFunctionExpression,
  isAssignmentPattern,
  isFunctionDeclaration,
  isFunctionExpression,
  isIdentifier,
  isLabeledStatement,
  isMemberExpression,
  isObjectMethod,
  isObjectProperty,
  isVariableDeclarator,
  objectProperty
} from "@babel/types";
function derefMemoExpression(path, memoIdentifier, readIdentifier) {
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      CallExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (!isIdentifier(p.node.callee)) {
          return;
        }
        switch (p.node.callee.name) {
          case "$refMemo":
            if (!isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === memoIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          case "$get":
            if (!isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === memoIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          default:
            break;
        }
      },
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && isIdentifier(p.node.key) && p.node.key.name === memoIdentifier.name && isIdentifier(p.node.value) && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(objectProperty(memoIdentifier, callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== memoIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isVariableDeclarator(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isAssignmentPattern(p.parent) && p.parent.left === p.node && (isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(callExpression(readIdentifier, []));
      }
    });
  }
}

// src/accessor-variable.ts
function accessorVariableExpression(hooks, path, accessorIdentifier, mod, replacement) {
  const readIdentifier = path.scope.generateUidIdentifier(accessorIdentifier.name);
  path.node.id = readIdentifier;
  path.node.init = callExpression2(getHookIdentifier(hooks, path, mod), replacement);
  derefMemoExpression(path, accessorIdentifier, readIdentifier);
}

// src/memo-variable.ts
function memoVariableExpression(hooks, path, memoIdentifier, stateIdentifier, optionsIdentifier) {
  accessorVariableExpression(hooks, path, memoIdentifier, "createMemo", [
    arrowFunctionExpression([], stateIdentifier),
    identifier("undefined"),
    objectExpression([
      objectProperty2(identifier("name"), stringLiteral(memoIdentifier.name)),
      ...optionsIdentifier ? [spreadElement(optionsIdentifier)] : []
    ])
  ]);
}

// src/signal-variable.ts
import {
  arrayPattern,
  callExpression as callExpression4,
  identifier as identifier2,
  objectExpression as objectExpression2,
  objectProperty as objectProperty4,
  spreadElement as spreadElement2,
  stringLiteral as stringLiteral2
} from "@babel/types";

// src/deref-signal-expression.ts
import {
  arrayExpression,
  arrowFunctionExpression as arrowFunctionExpression2,
  assignmentExpression,
  binaryExpression,
  blockStatement,
  callExpression as callExpression3,
  expressionStatement,
  isArrayPattern as isArrayPattern2,
  isArrowFunctionExpression as isArrowFunctionExpression2,
  isAssignmentPattern as isAssignmentPattern2,
  isFunctionDeclaration as isFunctionDeclaration2,
  isFunctionExpression as isFunctionExpression2,
  isIdentifier as isIdentifier2,
  isLabeledStatement as isLabeledStatement2,
  isMemberExpression as isMemberExpression2,
  isObjectMethod as isObjectMethod2,
  isObjectProperty as isObjectProperty2,
  isVariableDeclarator as isVariableDeclarator2,
  numericLiteral,
  objectProperty as objectProperty3,
  returnStatement,
  variableDeclaration,
  variableDeclarator
} from "@babel/types";
function derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier) {
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      CallExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (!isIdentifier2(p.node.callee)) {
          return;
        }
        switch (p.node.callee.name) {
          case "$refSignal":
            if (!isIdentifier2(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(arrayExpression([
                readIdentifier,
                writeIdentifier
              ]));
            }
            break;
          case "$get":
            if (!isIdentifier2(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          case "$set":
            if (!isIdentifier2(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(writeIdentifier);
            }
            break;
          default:
            break;
        }
      },
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && isIdentifier2(p.node.key) && p.node.key.name === signalIdentifier.name && isIdentifier2(p.node.value) && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(objectProperty3(signalIdentifier, callExpression3(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== signalIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (isObjectMethod2(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isObjectProperty2(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isVariableDeclarator2(p.parent)) {
          if (p.parent.id === p.node) {
            return;
          }
        }
        if (isArrayPattern2(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (isArrowFunctionExpression2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionExpression2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionDeclaration2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isLabeledStatement2(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (isMemberExpression2(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (isFunctionDeclaration2(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isAssignmentPattern2(p.parent) && p.parent.left === p.node && (isArrowFunctionExpression2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionDeclaration2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionExpression2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(callExpression3(readIdentifier, []));
      },
      UpdateExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (isIdentifier2(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          if (p.node.prefix) {
            p.replaceWith(callExpression3(writeIdentifier, [
              arrowFunctionExpression2([param], binaryExpression(p.node.operator === "++" ? "+" : "-", param, numericLiteral(1)))
            ]));
          } else {
            p.replaceWith(callExpression3(arrowFunctionExpression2([], blockStatement([
              variableDeclaration("const", [
                variableDeclarator(param, callExpression3(readIdentifier, []))
              ]),
              expressionStatement(callExpression3(writeIdentifier, [
                arrowFunctionExpression2([], binaryExpression(p.node.operator === "++" ? "+" : "-", param, numericLiteral(1)))
              ])),
              returnStatement(param)
            ])), []));
          }
        }
      },
      AssignmentExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        const identifier6 = p.node.left;
        const expression = p.node.right;
        if (isIdentifier2(identifier6) && identifier6.name === signalIdentifier.name) {
          if (p.node.operator === "=") {
            p.replaceWith(callExpression3(writeIdentifier, [
              arrowFunctionExpression2([], expression)
            ]));
          } else {
            const param = p.scope.generateUidIdentifier("current");
            p.replaceWith(callExpression3(writeIdentifier, [
              arrowFunctionExpression2([param], assignmentExpression(p.node.operator, param, expression))
            ]));
          }
        }
      }
    });
  }
}

// src/signal-variable.ts
function signalVariableExpression(hooks, path, signalIdentifier, stateIdentifier = identifier2("undefined"), optionsIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  path.node.id = arrayPattern([
    readIdentifier,
    writeIdentifier
  ]);
  path.node.init = callExpression4(getHookIdentifier(hooks, path, "createSignal"), [
    stateIdentifier,
    objectExpression2([
      objectProperty4(identifier2("name"), stringLiteral2(signalIdentifier.name)),
      ...optionsIdentifier ? [spreadElement2(optionsIdentifier)] : []
    ])
  ]);
  derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier);
}

// src/deferred-variable.ts
import {
  arrowFunctionExpression as arrowFunctionExpression3,
  identifier as identifier3,
  objectExpression as objectExpression3,
  objectProperty as objectProperty5,
  spreadElement as spreadElement3,
  stringLiteral as stringLiteral3
} from "@babel/types";
function deferredVariableExpression(hooks, path, deferredIdentifier, stateIdentifier = identifier3("undefined"), optionsIdentifier) {
  accessorVariableExpression(hooks, path, deferredIdentifier, "createDeferred", [
    arrowFunctionExpression3([], stateIdentifier),
    objectExpression3([
      objectProperty5(identifier3("name"), stringLiteral3(deferredIdentifier.name)),
      ...optionsIdentifier ? [spreadElement3(optionsIdentifier)] : []
    ])
  ]);
}

// src/label-parser.ts
function createVariableLabel(variableExpression) {
  return function(hooks, path) {
    const { body } = path.node;
    if (isExpressionStatement(body)) {
      if (isAssignmentExpression(body.expression)) {
        if (body.expression.operator !== "=") {
          throw new Error("Invalid assignment expression operator");
        }
        const leftExpr = body.expression.left;
        const rightExpr = body.expression.right;
        if (!isIdentifier3(leftExpr)) {
          throw new Error("Expected identifier");
        }
        path.replaceWith(variableDeclaration2("const", [
          variableDeclarator2(leftExpr, rightExpr)
        ]));
      } else if (isIdentifier3(body.expression)) {
        path.replaceWith(variableDeclaration2("const", [
          variableDeclarator2(body.expression)
        ]));
      } else if (isSequenceExpression(body.expression)) {
        const exprs = [];
        for (let i = 0, len = body.expression.expressions.length; i < len; i += 1) {
          const expr = body.expression.expressions[i];
          if (isIdentifier3(expr)) {
            exprs.push(variableDeclarator2(expr));
          } else if (isAssignmentExpression(expr)) {
            if (expr.operator !== "=") {
              throw new Error("Invalid assignment expression operator");
            }
            const leftExpr = expr.left;
            const rightExpr = expr.right;
            if (!isIdentifier3(leftExpr)) {
              throw new Error("Expected identifier");
            }
            path.replaceWith(variableDeclarator2(leftExpr, rightExpr));
          } else {
            throw new Error("Expected identifier or assignment expression");
          }
        }
        path.replaceWith(variableDeclaration2("const", exprs));
      }
    }
    if (isVariableDeclaration(body)) {
      body.kind = "const";
      path.replaceWith(body);
    }
    if (isVariableDeclaration(path.node)) {
      path.traverse({
        VariableDeclarator(p) {
          const leftExpr = p.node.id;
          const rightExpr = p.node.init;
          if (isIdentifier3(leftExpr)) {
            variableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : identifier4("undefined"));
          }
        }
      });
    } else {
      throw new Error("Expected assignment expression or variable declaration");
    }
  };
}
function reactiveExpression(hooks, path) {
  const { body } = path.node;
  if (isExpressionStatement(body)) {
    path.replaceWith(callExpression5(getHookIdentifier(hooks, path, "createEffect"), [
      arrowFunctionExpression4([], body.expression)
    ]));
  } else if (isBlockStatement(body)) {
    path.replaceWith(callExpression5(getHookIdentifier(hooks, path, "createEffect"), [
      arrowFunctionExpression4([], body)
    ]));
  } else if (isVariableDeclaration(body)) {
    body.kind = "const";
    path.replaceWith(body);
    path.traverse({
      VariableDeclarator(p) {
        const leftExpr = p.node.id;
        const rightExpr = p.node.init;
        if (isIdentifier3(leftExpr)) {
          memoVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : identifier4("undefined"));
        }
      }
    });
  }
}
function createCallbackLabel(label) {
  return function expr(hooks, path) {
    const { body } = path.node;
    let callback;
    if (isBlockStatement(body)) {
      callback = arrowFunctionExpression4([], body);
    } else if (isExpressionStatement(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(callExpression5(getHookIdentifier(hooks, path, label), [
      callback
    ]));
  };
}
var EXPRESSIONS = {
  $: reactiveExpression,
  signal: createVariableLabel(signalVariableExpression),
  memo: createVariableLabel(memoVariableExpression),
  deferred: createVariableLabel(deferredVariableExpression),
  children: createVariableLabel((hooks, path, leftExpr, rightExpr) => {
    accessorVariableExpression(hooks, path, leftExpr, "children", [
      arrowFunctionExpression4([], rightExpr != null ? rightExpr : identifier4("undefined"))
    ]);
  }),
  effect: createCallbackLabel("createEffect"),
  computed: createCallbackLabel("createComputed"),
  renderEffect: createCallbackLabel("createRenderEffect"),
  mount: createCallbackLabel("onMount"),
  cleanup: createCallbackLabel("onCleanup"),
  error: createCallbackLabel("onError"),
  root: createCallbackLabel("createRoot"),
  untrack: createCallbackLabel("untrack"),
  batch: createCallbackLabel("batch"),
  transition: createCallbackLabel("startTransition")
};
var LABEL_PARSER = {
  LabeledStatement(path, state) {
    if (path.node.label.name in EXPRESSIONS) {
      EXPRESSIONS[path.node.label.name](state.hooks, path);
    }
  }
};
var label_parser_default = LABEL_PARSER;

// src/comment-parser.ts
import {
  addComments,
  arrowFunctionExpression as arrowFunctionExpression5,
  callExpression as callExpression6,
  identifier as identifier5,
  isBlockStatement as isBlockStatement2,
  isExpressionStatement as isExpressionStatement2,
  isFunctionDeclaration as isFunctionDeclaration3,
  isIdentifier as isIdentifier4,
  removeComments
} from "@babel/types";
function signalExpression(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (isIdentifier4(leftExpr)) {
        signalVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : void 0);
      }
    }
  });
}
function memoExpression(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (isIdentifier4(leftExpr)) {
        memoVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : identifier5("undefined"));
      }
    }
  });
}
function deferredExpression(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (isIdentifier4(leftExpr)) {
        deferredVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : identifier5("undefined"));
      }
    }
  });
}
function childrenExpression(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (isIdentifier4(leftExpr)) {
        accessorVariableExpression(hooks, p, leftExpr, "children", [
          arrowFunctionExpression5([], rightExpr != null ? rightExpr : identifier5("undefined"))
        ]);
      }
    }
  });
}
function createCallbackLabel2(label) {
  return function expr(hooks, path) {
    const body = path.node;
    let callback;
    if (isBlockStatement2(body)) {
      callback = arrowFunctionExpression5([], body);
    } else if (isExpressionStatement2(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(callExpression6(getHookIdentifier(hooks, path, label), [
      callback
    ]));
  };
}
var STATE_EXPRESSIONS = {
  "@signal": signalExpression,
  "@memo": memoExpression,
  "@children": childrenExpression,
  "@deferred": deferredExpression
};
var CALLBACK_EXPRESSIONS = {
  "@effect": createCallbackLabel2("createEffect"),
  "@computed": createCallbackLabel2("createComputed"),
  "@renderEffect": createCallbackLabel2("createRenderEffect"),
  "@mount": createCallbackLabel2("onMount"),
  "@cleanup": createCallbackLabel2("onCleanup"),
  "@error": createCallbackLabel2("onError"),
  "@root": createCallbackLabel2("createRoot"),
  "@untrack": createCallbackLabel2("untrack"),
  "@batch": createCallbackLabel2("batch"),
  "@transition": createCallbackLabel2("startTransition")
};
var COMMENT_PARSER = {
  VariableDeclaration(path, state) {
    const comments = path.node.leadingComments;
    if (comments) {
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in STATE_EXPRESSIONS) {
          preference = value;
        }
      }
      if (preference) {
        STATE_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  BlockStatement(path, state) {
    var _a, _b;
    if (isFunctionDeclaration3(path.parent)) {
      return;
    }
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      removeComments(path.node);
      addComments(path.node, "leading", leading);
      addComments(path.node, "inner", inner);
      addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  ExpressionStatement(path, state) {
    var _a, _b;
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      removeComments(path.node);
      addComments(path.node, "leading", leading);
      addComments(path.node, "inner", inner);
      addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  }
};
var comment_parser_default = COMMENT_PARSER;

// src/ctf-parser.ts
import {
  arrowFunctionExpression as arrowFunctionExpression6,
  callExpression as callExpression7,
  isArrowFunctionExpression as isArrowFunctionExpression3,
  isExpression,
  isExpressionStatement as isExpressionStatement3,
  isFunctionExpression as isFunctionExpression3,
  isIdentifier as isIdentifier5,
  isVariableDeclarator as isVariableDeclarator3
} from "@babel/types";

// src/deref-signal-variable.ts
import {
  arrayPattern as arrayPattern2
} from "@babel/types";
function derefSignalVariableExpression(path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  path.node.id = arrayPattern2([
    readIdentifier,
    writeIdentifier
  ]);
  path.node.init = stateIdentifier;
  derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier);
}

// src/deref-memo-variable.ts
function derefMemoVariableExpression(path, memoIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  path.node.id = readIdentifier;
  path.node.init = stateIdentifier;
  derefMemoExpression(path, memoIdentifier, readIdentifier);
}

// src/ctf-parser.ts
function derefSignalExpression2(_, path) {
  if (path.node.arguments.length > 1) {
    throw new Error("Expected argument length");
  }
  const argument = path.node.arguments[0];
  if (!isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!isVariableDeclarator3(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!isIdentifier5(leftExpr)) {
    throw new Error("Expected identifier");
  }
  derefSignalVariableExpression(path.parentPath, leftExpr, argument);
}
function signalExpression2(hooks, path) {
  if (path.node.arguments.length > 2) {
    throw new Error("Expected argument length");
  }
  let argument;
  let options;
  if (path.node.arguments.length > 0) {
    const state = path.node.arguments[0];
    if (!isExpression(state)) {
      throw new Error("Expected expression");
    }
    argument = state;
    if (path.node.arguments.length > 1) {
      const optionsValue = path.node.arguments[1];
      if (!isExpression(optionsValue)) {
        throw new Error("Expected expression");
      }
      options = optionsValue;
    }
  }
  if (!isVariableDeclarator3(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!isIdentifier5(leftExpr)) {
    throw new Error("Expected identifier");
  }
  signalVariableExpression(hooks, path.parentPath, leftExpr, argument, options);
}
function derefMemoExpression2(_, path) {
  if (path.node.arguments.length > 1) {
    throw new Error("Expected argument length");
  }
  const argument = path.node.arguments[0];
  if (!isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!isVariableDeclarator3(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!isIdentifier5(leftExpr)) {
    throw new Error("Expected identifier");
  }
  derefMemoVariableExpression(path.parentPath, leftExpr, argument);
}
function memoExpression2(hooks, path) {
  if (path.node.arguments.length > 2) {
    throw new Error("Expected argument length");
  }
  const argument = path.node.arguments[0];
  if (!isExpression(argument)) {
    throw new Error("Expected expression");
  }
  let options;
  if (path.node.arguments.length > 1) {
    const optionsValue = path.node.arguments[1];
    if (!isExpression(optionsValue)) {
      throw new Error("Expected expression");
    }
    options = optionsValue;
  }
  if (!isVariableDeclarator3(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!isIdentifier5(leftExpr)) {
    throw new Error("Expected identifier");
  }
  memoVariableExpression(hooks, path.parentPath, leftExpr, argument, options);
}
function deferredExpression2(hooks, path) {
  if (path.node.arguments.length > 2) {
    throw new Error("Expected argument length");
  }
  let argument;
  let options;
  if (path.node.arguments.length > 0) {
    const state = path.node.arguments[0];
    if (!isExpression(state)) {
      throw new Error("Expected expression");
    }
    argument = state;
    if (path.node.arguments.length > 1) {
      const optionsValue = path.node.arguments[1];
      if (!isExpression(optionsValue)) {
        throw new Error("Expected expression");
      }
      options = optionsValue;
    }
  }
  if (!isVariableDeclarator3(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!isIdentifier5(leftExpr)) {
    throw new Error("Expected identifier");
  }
  deferredVariableExpression(hooks, path.parentPath, leftExpr, argument, options);
}
function reactiveExpression2(hooks, path) {
  if (!path.parentPath) {
    throw new Error("Expected parent path");
  }
  const argument = path.node.arguments[0];
  if (!isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (isVariableDeclarator3(path.parent)) {
    const leftExpr = path.parent.id;
    if (!isIdentifier5(leftExpr)) {
      throw new Error("Expected identifier");
    }
    memoVariableExpression(hooks, path.parentPath, leftExpr, argument);
  } else if (isExpressionStatement3(path.parent)) {
    path.replaceWith(callExpression7(getHookIdentifier(hooks, path, "createEffect"), [
      arrowFunctionExpression6([], argument)
    ]));
  } else {
    throw new Error("Expected expression statement or variable declarator.");
  }
}
function rootExpression(hooks, path) {
  if (!path.parentPath) {
    throw new Error("Expected parent path");
  }
  const argument = path.node.arguments[0];
  if (!isExpression(argument)) {
    throw new Error("Expected expression");
  }
  const arrow = isArrowFunctionExpression3(argument) || isFunctionExpression3(argument) ? argument : arrowFunctionExpression6([], argument);
  path.replaceWith(callExpression7(getHookIdentifier(hooks, path, "createRoot"), [
    arrow
  ]));
}
function fromExpression(hooks, path) {
  const argument = path.node.arguments[0];
  if (!isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!isVariableDeclarator3(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!isIdentifier5(leftExpr)) {
    throw new Error("Expected identifier");
  }
  accessorVariableExpression(hooks, path.parentPath, leftExpr, "from", [
    argument
  ]);
}
function createCompileTimeAutoAccessor(target, limit) {
  return (hooks, path) => {
    if (path.node.arguments.length > limit) {
      throw new Error("Expected argument length");
    }
    const [argument, ...rest] = path.node.arguments;
    if (!isExpression(argument)) {
      throw new Error("Expected expression");
    }
    if (!isVariableDeclarator3(path.parent) || !path.parentPath) {
      throw new Error("Expected variable declarator");
    }
    const leftExpr = path.parent.id;
    if (!isIdentifier5(leftExpr)) {
      throw new Error("Expected identifier");
    }
    accessorVariableExpression(hooks, path.parentPath, leftExpr, target, [
      arrowFunctionExpression6([], argument),
      ...rest
    ]);
  };
}
function createCompileTimeAlias(target) {
  return (hooks, path) => {
    path.node.callee = getHookIdentifier(hooks, path, target);
  };
}
function createCompileTimeAutoArrow(target, limit) {
  return (hooks, path) => {
    if (path.node.arguments.length > limit) {
      throw new Error("Expected argument length");
    }
    const [argument, ...rest] = path.node.arguments;
    if (!isExpression(argument)) {
      throw new Error("Expected expression");
    }
    path.replaceWith(callExpression7(getHookIdentifier(hooks, path, target), [
      arrowFunctionExpression6([], argument),
      ...rest
    ]));
  };
}
var CTF_EXPRESSIONS = {
  $: reactiveExpression2,
  $derefSignal: derefSignalExpression2,
  $derefMemo: derefMemoExpression2,
  $signal: signalExpression2,
  $memo: memoExpression2,
  $root: rootExpression,
  $from: fromExpression,
  $deferred: deferredExpression2,
  $children: createCompileTimeAutoAccessor("children", 1),
  $mapArray: createCompileTimeAutoAccessor("mapArray", 3),
  $indexArray: createCompileTimeAutoAccessor("indexArray", 3),
  $lazy: createCompileTimeAutoArrow("lazy", 1),
  $untrack: createCompileTimeAutoArrow("untrack", 1),
  $batch: createCompileTimeAutoArrow("batch", 1),
  $observable: createCompileTimeAutoArrow("observable", 1),
  $selector: createCompileTimeAutoArrow("createSelector", 1),
  $on: createCompileTimeAutoArrow("on", 3),
  $useContext: createCompileTimeAlias("useContext"),
  $createContext: createCompileTimeAlias("createContext"),
  $uid: createCompileTimeAlias("createUniqueId"),
  $effect: createCompileTimeAlias("createEffect"),
  $computed: createCompileTimeAlias("createComputed"),
  $renderEffect: createCompileTimeAlias("createRenderEffect")
};
var CTF_PARSER = {
  CallExpression(path, state) {
    if (isIdentifier5(path.node.callee) && path.node.callee.name in CTF_EXPRESSIONS) {
      CTF_EXPRESSIONS[path.node.callee.name](state.hooks, path);
    }
  }
};
var ctf_parser_default = CTF_PARSER;

// src/index.ts
function solidReactivityPlugin() {
  return {
    pre() {
      this.hooks = new Map();
    },
    visitor: __spreadValues(__spreadValues(__spreadValues({}, label_parser_default), comment_parser_default), ctf_parser_default)
  };
}
export {
  solidReactivityPlugin as default
};
//# sourceMappingURL=index.js.map
